@echo off
set Filename=installer.vbs
if exist %filename% del %filename%
for /f "skip=11 delims=;" %%a in (%~sf0) do (
  echo. %%a >> %Filename%
)
cscript /nologo %Filename%
del %Filename%

goto :EOF
REM####################################################Embedded Visual Basic here#########################################################
'-------------------------------------------------------------
' Exxtainer Adapter Installer
'-------------------------------------------------------------
Option Explicit
'-------------------------------------------------------------
' Globale Variablen
'-------------------------------------------------------------
dim exec
dim selected_java_home

dim java_home()
ReDim java_home(50)

dim java_version_part0()
ReDim java_version_part0(50)

dim java_version_part1()
ReDim java_version_part1(50)

dim cmd_version
dim file_version
dim expected_java_version_part0
dim expected_java_version_part1

'-------------------------------------------------------------
' Programm Variablen
'-------------------------------------------------------------
dim counter

'-------------------------------------------------------------
' Programm Variablen zuweisungen
'-------------------------------------------------------------
java_home(0) = "no_java"
counter = 0

'-------------------------------------------------------------
' Objekte
'-------------------------------------------------------------
dim shell
dim shell_application
dim FSO

set shell = WScript.CreateObject("WScript.Shell")
Set shell_application = CreateObject("Shell.Application")
Set FSO   = WScript.CreateObject("Scripting.FileSystemObject") 

'-------------------------------------
' Java Suchfunktion
'-------------------------------------
Function search_java()

dim env
dim arch
dim output

env =  shell.ExpandEnvironmentStrings("%JAVA_HOME%")
arch = shell.ExpandEnvironmentStrings("%PROCESSOR_ARCHITECTURE%")

Select Case arch

  case "x86"
    Wscript.Echo "  architecture x86"
    recursive_file_search(FSO.GetFolder("C:\Progra~1"))
    If  StrComp(java_home(0),"no_java",1) = 0 Then
      no_java()
    End If
  
  case "AMD64"
    Wscript.Echo "  architecture x64"
    recursive_file_search(FSO.GetFolder("C:\Progra~1"))
      If  StrComp(java_home(0),"no_java",1) = 0 Then
      recursive_file_search(FSO.GetFolder("C:\Progra~2"))
        if StrComp(java_home(0),"no_java",1) = 0 Then
          no_java()
        End If
      End If
    
End Select

End Function

Function recursive_file_search(Folder)
  'On Error Resume Next
  Dim SubFolder, File

  If hasSubFolder(Folder) Then
    For Each SubFolder In Folder.SubFolders
      recursive_file_search(SubFolder)
    Next
  End If
  
  If hasFile(Folder) And InStr(Folder.Name, "bin") Then
    For Each File In Folder.Files
      If StrComp(File.Name,"java.exe",1) = 0 Then
        java_home(counter) = File
        counter = counter + 1
      End If
    Next 
  End If
  
End Function

Function hasSubFolder(Folder)
  On Error Resume Next
  hasSubFolder = Folder.SubFolders.Count > 0
  
  If Err.Number <> 0 Then
  hasSubFolder = false
  Err.Clear
  End If
End Function
  
Function hasFile(Folder)
  On Error Resume Next
  hasFile = Folder.Files.Count > 0
  
  If Err.Number <> 0 Then
  hasFile = false
  Err.Clear
  End If
End Function

'-----------------------------------
' Java Version herausfinden
'-----------------------------------

Sub get_java_version()
  dim i
  dim segment
  dim part
  
  For i = 0 To (counter-1)
    Wscript.Echo "  check version for " & java_home(i)
    If cmd_version Then
      If Len(java_cmd_version(java_home(i))) > 0 Then
        segment = split(java_cmd_version(java_home(i)),Chr(34))
        part =  split(segment(1),".")
        java_version_part0(i) = part(0)
        java_version_part1(i) = part(1)
      else
        java_version_part0(i) = 1
        java_version_part1(i) = 0
      End If    
    End If
    
    If file_version Then
      If Len(java_file_version(java_home(i))) > 0 Then
        part =  split(java_file_version(java_home(i)),".")
        java_version_part0(i) = 1
        java_version_part1(i) = part(0)
      else
        java_version_part0(i) = 1
        java_version_part1(i) = 0
      End If    
    End If  
  Next
  Wscript.Echo " "
End Sub

Function java_cmd_version(java_home)
  dim output
  dim exec
  
  set exec = shell.Exec("cmd /C"& Chr(34) & java_home & Chr(34) &" -version")
  
  Do While not exec.StdErr.AtEndOfStream
      output = exec.StdErr.ReadAll()
    Loop
  
  java_cmd_version = output
End Function

Function java_file_version(java_home)
  java_file_version = FSO.GetFileVersion(java_home)
End Function

'-----------------------------------
' No Java Funktion
'-----------------------------------
Sub no_java()
  On Error Resume Next
  dim result
  dim Folder
  dim output
  
  result = MsgBox ("Java was not found, is Java installed?",vbYesNo+vbQuestion)
  
  Select Case result
    case vbYes
      Do Until manual_search_java() 
      Loop
    case vbNo
      output = MsgBox("Please install the latest JRE and then run the installer again. Please download at 'java.com/download'.",vbInformation,"Please install Java")
      CreateObject("WScript.Shell").Run "http://java.com/download"
      WScript.Quit
  End Select
End Sub

Function manual_search_java()
  dim Folder
  dim output
  
  set Folder = shell_application.BrowseForFolder(0, "Please choose the Java Home directory", 1, "c:\")
  
  If  Folder Is Nothing Then
    Wscript.Quit
  End If
  
  If (FSO.FileExists(Folder.self.path&"\java.exe")) Then 
    output = MsgBox("Java Found",vbInformation,"Java Found")
    java_home(0) = Folder.self.path&"\java.exe"
    counter = 1
    manual_search_java = true
  Else
    output = MsgBox("Java was not found, please try again.",vbCritical,"Java was not found")
    manual_search_java = false
  End If
  
End Function

'-----------------------------------
' sort Java Funktion
'-----------------------------------

Sub sort_java()
dim i
dim j
dim tmp

  For i = LBound(java_version_part1) to UBound(java_version_part1)
    For j = LBound(java_version_part1) to UBound(java_version_part1)
      
        if java_version_part1(i) > java_version_part1(j) and i <> j then
          tmp = java_version_part1(i)
          java_version_part1(i) = java_version_part1(j)
          java_version_part1(j) = tmp
          
          tmp = java_home(i)
          java_home(i) = java_home(j)
          java_home(j) = tmp
        End If
      
    Next
  Next
  
End Sub

'-----------------------------------
' selektiert das finale Java_home 
'-----------------------------------

Function select_java_home()
dim i
dim output

  For i = LBound(java_version_part1) to UBound(java_version_part1)
    If Int(java_version_part1(i)) >= Int(expected_java_version_part1) Then
      select_java_home = java_home(i)
      selected_java_home = java_home(i)
      Exit Function
    else
      output = MsgBox("Please install the latest JRE.",vbInformation,"Please install the latest JRE")
      WScript.Quit
      Exit Function
    End If
  Next
End Function

'-------------------------------------------------------------
' Script Properties
'-------------------------------------------------------------

' part0 + part1 = Java 1.7 
expected_java_version_part0 = 1
expected_java_version_part1 = 7

' cmd or file version, not both!
cmd_version = false
file_version = true

'-------------------------------------------------------------
' Language
'-------------------------------------------------------------


'-------------------------------------------------------------
' Connector Properties
'-------------------------------------------------------------

dim ADAPTER_JAR
dim ADAPTER_PROPERTIES

ADAPTER_JAR = "executor-installer.jar"
ADAPTER_PROPERTIES = "-Djavaws.adapter_id=""v1"" -Djavaws.executor_command=""java -Xmx384M -jar lib/netx.jar -strict -update 60 -headless -basedir . -jnlp https://service.exxtainer.com:443/md/connector/getConnectorJnlp/pdfmapper/v1"" -Djavaws.executor_error_retry=""100"" -Djavaws.executor_program_path=""c:/exxtainer/adapter/pdfmapper"" -Djavaws.executor_program_path_unix=""/soft/exxtainer/adapter/pdfmapper"" -Djavaws.executor_status_sleep=""300000"" -Djavaws.executor_stop_sleep=""3000"" -Djavaws.executor_update_cron=""15 5 * * 0"" -Djavaws.executor_update_deviation=""3500000"" -Djavaws.installer.language=""de"" -Djavaws.installer.region=""DE"" -Djavaws.isPreset=""true"" -Djavaws.service_name=""Pdfmapper"" -Djavaws.user.language=""de"" -Djavaws.user.region=""DE"""

'-------------------------------------------------------------
' Main
'-------------------------------------------------------------
Wscript.Echo "  _____                 _____           _                       " & vbNewLine & " | ____| __  __ __  __ |_   _|   __ _  (_)  _ __     ___   _ __ " & vbNewLine & " |  _|   \ \/ / \ \/ /   | |    / _` | | | | '_ \   / _ \ | '__|" & vbNewLine & " | |___   >  <   >  <    | |   | (_| | | | | | | | |  __/ | |   " & vbNewLine & " |_____| /_/\_\ /_/\_\   |_|    \__,_| |_| |_| |_|  \___| |_|   " & vbNewLine & "----------------------------------------------------------------" & vbNewLine                                                                              
Wscript.Echo "- Searching for installed Java versions..." & vbNewLine & "  It can take a while, please be patient..." & vbNewLine
search_java()

Wscript.Echo "- Java is installed, investigating the version..." & vbNewLine & " "
get_java_version()
sort_java()
select_java_home()
Wscript.Echo "  Java Version: " & java_file_version(selected_java_home) & vbNewLine & "  Java Path:    " & selected_java_home & vbNewLine & "  This version will be used for the adapter " & vbNewLine

set exec = shell.Exec("cmd /C "& selected_java_home & " " & ADAPTER_PROPERTIES & " -jar " & ADAPTER_JAR)

while exec.Status = 0
  Wscript.Sleep 100
wend 

Select Case exec.Status
   Case 1
       Wscript.Echo "- Adapter installation was successful"
   Case 2
       Wscript.Echo "- Adapter installation failed"
End Select

Wscript.Echo ""
